/*
    This file is part of ben -- a task scheduler for distributed computations
    Copyright (C) 2012-2024  Laurent Poirrier

    ben is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef BEN_CMDLINE_H
#define BEN_CMDLINE_H
#include <stdio.h>
#include "buffer.h"
#include "strlist.h"
#include "config.h"

typedef struct args_t {
	int argc;
	char **argv;
	buffer buff;
	strlist str;
} args;

void arg_init(args *a, int argc, char **argv);
void arg_clear(args *a);

void arg_hook(args *a, char *str);

int  arg_remain(args *a);
int  arg_finish(args *a);


int arg_switch(args *a, char *sd, char *ld);

char *arg_str(args *a,
	char *sd, char *ld, char *sf, char *lf,
	char *def_val);

int arg_int(args *a, char *sd, char *ld, int def_val);

int arg_strlist(args *a,
	char *sd, char *ld, char *sf, char *lf,
	strlist *l);




#endif

