/*
    This file is part of ben -- a task scheduler for distributed computations
    Copyright (C) 2012-2024  Laurent Poirrier

    ben is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef BEN_ARRAY_H
#define BEN_ARRAY_H
#include <unistd.h>

typedef struct array_t {
	size_t mask, n, alloc, cell;
	void *data;
} array;

void array_init(array *a, size_t cell, size_t gran);
void array_clear(array *a);
void array_reset(array *a);

void array_alloc(array *a, size_t n);
void *array_get(array *a, size_t n);

void array_append(array *a, void *data, size_t n);

#endif

