/*
    This file is part of ben -- a task scheduler for distributed computations
    Copyright (C) 2012-2024  Laurent Poirrier

    ben is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef BEN_DATE_H
#define BEN_DATE_H
#include <stdio.h>
#include <time.h>
#include <stdint.h>

typedef struct timespec gtime;

gtime gtime_zero(void);
gtime gtime_wall(void);
gtime gtime_mono(void);
gtime gtime_s(uint64_t s);
gtime gtime_ms(uint64_t ms);
gtime gtime_add(gtime a, gtime b);
gtime gtime_sub(gtime a, gtime b);
int gtime_nonzero(gtime a);
int gtime_ge(gtime a, gtime b);
uint64_t gtime_get_s(gtime a);
uint64_t gtime_get_ms(gtime a);
uint64_t gtime_get_ns(gtime a);


typedef struct gtime_str_t {
	char s[40];
} gtime_str;

#define GTIME_DAYS	1
#define GTIME_SUBSEC	2

gtime_str duration_str(gtime dur, int flags);
gtime_str date_str(gtime t, int flags);
gtime_str curdate_str(int flags);



#endif


