/*
    This file is part of ben -- a task scheduler for distributed computations
    Copyright (C) 2012-2024  Laurent Poirrier

    ben is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef BEN_NETWORK_H
#define BEN_NETWORK_H
#include <string.h>

int socket_bind(char *addr);
int socket_unbind(int sfd, char *addr);
int socket_accept(int sfd);

int socket_connect(char *addr);


#define SOCKET_UNIX	0
#define SOCKET_INET	1

#define SOCKET_PATH_LEN		1025
#define SOCKET_SERV_LEN		32

typedef struct socket_addr_t {
	int type;
	char path[SOCKET_PATH_LEN];
	char serv[SOCKET_SERV_LEN];
} socket_addr;

int socket_addr_parse(socket_addr *r, char *s);


#endif

